<template>
  <div class="row">
    <div class="col-12">
      <div class="card">
        <div class="card-header">
          <h4 class="card-title">Calendar</h4>
          <div class="heading-elements">
            <ul class="list-inline mb-0">
              <li><a data-action="reload" @click="reload()"><i class="ft-rotate-cw"/></a></li>
            </ul>
          </div>
        </div>
        <div class="card-content collapse show">
          <div class="card-body">
            <full-calendar id="calendar" ref="calendar" :events="getAppointments" :config="config"/>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import moment from 'moment'
import _ from 'lodash'
import to from 'await-to-js'
import Swal from 'sweetalert2'
export default {
  name: 'Calendar',
  components: {
    moment,
    Swal
  },
  data() {
    return {
      token: this.$route.query.id,
      form: {},
      response: '',
      events: [],
      config: {
        defaultView: 'month',
        selectable: true,
        editable: true,
        eventLimit: true,
        height: 900,
        nowIndicator: true,
        displayEventEnd: true,
        dayClick: this.dayClick,
        select: this.select,
        eventClick: this.eventClick,
        eventResize: this.eventResize,
        eventDrop: this.eventDrop
      }
    }
  },
  async mounted() {
    const appNbr = this.$route.query.id
    const data = _.find(this.getAppointments, { id: Number(appNbr) })
    if (this.token) {
      this.$router.replace('/calendar')
      this.response = 'Appointment Cancelled'
      this.appoint(
        moment().format('YYYY-MM-DDTHH:mm'),
        this.token,
        this.response,
        data
      )
    }
  },
  async asyncData({ app, params }) {
    const n = 'tammy-NAS'
    let [errComp, appRequest] = await to(
      app.$axios.$get(`/api/appRequests?appraiserUsername=${n}`)
    )

    let getAppointments = []
    if (appRequest) {
      getAppointments = _.map(
        _.get(appRequest, '_embedded.appRequestResourceList'),
        c => ({
          id: c.appRequestNbr,
          start: c.appointmentTimestamp,
          title: c.appRequestNbr,
          details: c
        })
      )
    } else {
      Swal.fire('Error!', errComp, 'error')
      getAppointments = []
    }
    return { getAppointments }
  },
  methods: {
    async appoint(startDate, id, message, appointment) {
      const { value: evt } = await Swal.fire({
        title: 'Set an Appointment',
        html:
          '<div style="text-align:left">' +
          '<b>Request Number:</b> <span id="reqNbr"/></span><br>' +
          '<b>Address:</b> <span id="appAddress"/></span><br>' +
          '<b>Contact No:</b> <span id="contactTel"/></span><br>' +
          '<b>Appointment Date:</b> <input type="datetime-local" id="startDate" class="form-control">' +
          '</div>',
        type: 'info',
        showCancelButton: true,
        onOpen: function(ele) {
          const dateTime = ($(ele).find('#startDate')[0].value = startDate)
          const reqId = ($(ele).find('#reqNbr')[0].innerHTML = id)
          const appAddress = ($(ele).find('#appAddress')[0].innerHTML =
            appointment.details.appAddress)
          const contactTel = ($(ele).find('#contactTel')[0].innerHTML =
            appointment.details.appContactTel)
        }
      })
      if (evt) {
        const appTimeStamp = document.getElementById('startDate').value
        this.form.appRequestNbr = id
        this.form.appointmentTimestamp = appTimeStamp
        this.response = 'Appointment Successfully Updated'
        this.updateAppointment(this.form, this.response)
      } else {
        Swal.fire('Cancelled!', message, 'error')
      }
    },
    async updateAppointment(form, message) {
      let [err, rule] = await to(
        this.$axios.$put(`/api/appRequests/${form.appRequestNbr}`, form)
      )
      if (rule) {
        Swal.fire('Success!', message, 'success').then(result => {
          if (result.value) {
            this.reload()
          }
        })
      } else {
        Swal.fire('Error!', 'Updating Appointment Error!', 'error')
      }
    },
    async action(appointment) {
      await Swal.fire({
        type: 'question',
        title: 'Choose an action',
        showCancelButton: true,
        confirmButtonText: 'Edit',
        cancelButtonText: 'Delete'
      }).then(result => {
        if (result.value) {
          const getDateTime = appointment.start._i
          const extractedDateTime = moment(getDateTime).format(
            'YYYY-MM-DDTHH:mm'
          )
          this.response = 'Updating Appointment Cancelled'
          this.appoint(
            extractedDateTime,
            appointment.id,
            this.response,
            appointment
          )
        } else if (result.dismiss === 'cancel') {
          this.deleteAppointment(appointment)
        } else {
          return
        }
      })
    },
    async deleteAppointment(info) {
      await Swal.fire({
        type: 'question',
        title: 'Are you sure you want to delete?',
        showCancelButton: true,
        focusCancel: true
      }).then(result => {
        if (result.value) {
          const getDateTime = info.start._i
          this.form.appRequestNbr = info.id
          this.form.appointmentTimestamp = null
          this.response = 'Appointment Successfully Deleted'
          this.updateAppointment(this.form, this.response)
        }
      })
    },
    reload() {
      window.location.reload()
    },
    populateDate(id, start, end) {
      this.form.appointmentTimestamp = start
      this.form.appRequestNbr = id
      this.response = 'Appointment Successfully Updated'
      this.updateAppointment(this.form, this.response)
    },
    dayClick: function(date) {
      console.log('dayClick', moment(date).format())
    },
    select: function(startDate, endDate) {
      console.log('select', startDate.format(), endDate.format())
      console.log(moment(startDate._i).format('YYYY-MM-DDTHH:mm'))
    },
    eventClick: function(info) {
      this.action(info)
    },
    eventResize: function(info) {
      this.populateDate(info.id, info.start.format())
    },
    eventDrop: function(info) {
      this.populateDate(info.id, info.start.format())
    }
  }
}
</script>
